{-----------------------------------------------------------------------------}
{   Code source  utilis dans la leon 4 du Guide Pratique de
{   la programmation de directshow sous delphi publi par Paul Glagla
{   sur le site http://paul.glagla.free.fr
{
{-----------------------------------------------------------------------------}
unit main;

{-----------------------------------------------------------------------------}
interface

{-----------------------------------------------------------------------------}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,ConvertirDVunit, ExtCtrls,directshow9;

{-----------------------------------------------------------------------------}
type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    QuitterBtn: TBitBtn;
    ConvertirBtn: TBitBtn;
    StopBtn: TBitBtn;
    OuvrirBtn: TBitBtn;
    Panel1: TPanel;
    procedure OuvrirBtnClick(Sender: TObject);
    procedure QuitterBtnClick(Sender: TObject);
    procedure ConvertirBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure FilterGraph1GraphComplete(sender: TObject; Result: HRESULT;
  Renderer: IBaseFilter);
private
    { Private declarations }
  public
    { Public declarations }
  end;

{-----------------------------------------------------------------------------}
var
  Form1: TForm1;

{-----------------------------------------------------------------------------}
implementation
{$R *.dfm}

{-----------------------------------------------------------------------------}
procedure TForm1.OuvrirBtnClick(Sender: TObject);
var fic1,fic2,fic:string;
begin
if not opendialog1.Execute then exit;
convertirBtn.Enabled:=false;
stopBtn.enabled:=false;
fic:=opendialog1.FileName;
fic2:=changefileext(fic,'_type2.avi');
fic1:=changefileext(fic,'_type1.avi');
if dm.buildgraphDV1to2(fic,fic2) then begin
    panel1.Caption:=fic+' est de type 1';
    convertirBtn.Enabled:=true;
  end
  else
  if dm.buildgraphDV2to1(fic,fic1) then begin
    panel1.Caption:=fic+' est de type 2';
    convertirBtn.Enabled:=true;
  end
  else begin
    panel1.Caption:=fic+ ' n''est pas un fichier DV';
  end;

end;

{-----------------------------------------------------------------------------}
procedure TForm1.QuitterBtnClick(Sender: TObject);
begin
close;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.ConvertirBtnClick(Sender: TObject);
begin
stopBtn.Enabled:=true;
dm.FilterGraph1.Play;
panel1.Color:=clred;
dm.FilterGraph1.OnGraphComplete:=Filtergraph1GraphComplete;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.StopBtnClick(Sender: TObject);
begin
dm.FilterGraph1.Stop;
panel1.color:=clBtnFace;
end;

{-----------------------------------------------------------------------------}
procedure TForm1.FilterGraph1GraphComplete(sender: TObject; Result: HRESULT;
  Renderer: IBaseFilter);
begin
panel1.color:=clBtnFace;
stopBtn.enabled:=false;
end;

{-----------------------------------------------------------------------------}
end.
